package address_purification

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeProduct invokes the address_purification.DescribeProduct API synchronously
// api document: https://help.aliyun.com/api/address-purification/describeproduct.html
func (client *Client) DescribeProduct(request *DescribeProductRequest) (response *DescribeProductResponse, err error) {
	response = CreateDescribeProductResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeProductWithChan invokes the address_purification.DescribeProduct API asynchronously
// api document: https://help.aliyun.com/api/address-purification/describeproduct.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeProductWithChan(request *DescribeProductRequest) (<-chan *DescribeProductResponse, <-chan error) {
	responseChan := make(chan *DescribeProductResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeProduct(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeProductWithCallback invokes the address_purification.DescribeProduct API asynchronously
// api document: https://help.aliyun.com/api/address-purification/describeproduct.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeProductWithCallback(request *DescribeProductRequest, callback func(response *DescribeProductResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeProductResponse
		var err error
		defer close(result)
		response, err = client.DescribeProduct(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeProductRequest is the request struct for api DescribeProduct
type DescribeProductRequest struct {
	*requests.RpcRequest
	ServiceCode string `position:"Body" name:"ServiceCode"`
	Parameters  string `position:"Body" name:"Parameters"`
}

// DescribeProductResponse is the response struct for api DescribeProduct
type DescribeProductResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	Success    string `json:"Success" xml:"Success"`
	Code       string `json:"Code" xml:"Code"`
	ErrMessage string `json:"ErrMessage" xml:"ErrMessage"`
	Data       string `json:"Data" xml:"Data"`
}

// CreateDescribeProductRequest creates a request to invoke DescribeProduct API
func CreateDescribeProductRequest() (request *DescribeProductRequest) {
	request = &DescribeProductRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("address-purification", "2019-11-18", "DescribeProduct", "", "")
	return
}

// CreateDescribeProductResponse creates a response to parse from DescribeProduct response
func CreateDescribeProductResponse() (response *DescribeProductResponse) {
	response = &DescribeProductResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
