package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DownloadBasicStatisticsReport invokes the outboundbot.DownloadBasicStatisticsReport API synchronously
// api document: https://help.aliyun.com/api/outboundbot/downloadbasicstatisticsreport.html
func (client *Client) DownloadBasicStatisticsReport(request *DownloadBasicStatisticsReportRequest) (response *DownloadBasicStatisticsReportResponse, err error) {
	response = CreateDownloadBasicStatisticsReportResponse()
	err = client.DoAction(request, response)
	return
}

// DownloadBasicStatisticsReportWithChan invokes the outboundbot.DownloadBasicStatisticsReport API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/downloadbasicstatisticsreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DownloadBasicStatisticsReportWithChan(request *DownloadBasicStatisticsReportRequest) (<-chan *DownloadBasicStatisticsReportResponse, <-chan error) {
	responseChan := make(chan *DownloadBasicStatisticsReportResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DownloadBasicStatisticsReport(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DownloadBasicStatisticsReportWithCallback invokes the outboundbot.DownloadBasicStatisticsReport API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/downloadbasicstatisticsreport.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DownloadBasicStatisticsReportWithCallback(request *DownloadBasicStatisticsReportRequest, callback func(response *DownloadBasicStatisticsReportResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DownloadBasicStatisticsReportResponse
		var err error
		defer close(result)
		response, err = client.DownloadBasicStatisticsReport(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DownloadBasicStatisticsReportRequest is the request struct for api DownloadBasicStatisticsReport
type DownloadBasicStatisticsReportRequest struct {
	*requests.RpcRequest
	InstanceId string `position:"Query" name:"InstanceId"`
	JobGroupId string `position:"Query" name:"JobGroupId"`
}

// DownloadBasicStatisticsReportResponse is the response struct for api DownloadBasicStatisticsReport
type DownloadBasicStatisticsReportResponse struct {
	*responses.BaseResponse
	RequestId      string         `json:"RequestId" xml:"RequestId"`
	Success        bool           `json:"Success" xml:"Success"`
	Code           string         `json:"Code" xml:"Code"`
	Message        string         `json:"Message" xml:"Message"`
	HttpStatusCode int            `json:"HttpStatusCode" xml:"HttpStatusCode"`
	DownloadParams DownloadParams `json:"DownloadParams" xml:"DownloadParams"`
}

// CreateDownloadBasicStatisticsReportRequest creates a request to invoke DownloadBasicStatisticsReport API
func CreateDownloadBasicStatisticsReportRequest() (request *DownloadBasicStatisticsReportRequest) {
	request = &DownloadBasicStatisticsReportRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "DownloadBasicStatisticsReport", "outboundbot", "openAPI")
	return
}

// CreateDownloadBasicStatisticsReportResponse creates a response to parse from DownloadBasicStatisticsReport response
func CreateDownloadBasicStatisticsReportResponse() (response *DownloadBasicStatisticsReportResponse) {
	response = &DownloadBasicStatisticsReportResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
