package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetJobByPhoneNumber invokes the outboundbot.GetJobByPhoneNumber API synchronously
// api document: https://help.aliyun.com/api/outboundbot/getjobbyphonenumber.html
func (client *Client) GetJobByPhoneNumber(request *GetJobByPhoneNumberRequest) (response *GetJobByPhoneNumberResponse, err error) {
	response = CreateGetJobByPhoneNumberResponse()
	err = client.DoAction(request, response)
	return
}

// GetJobByPhoneNumberWithChan invokes the outboundbot.GetJobByPhoneNumber API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/getjobbyphonenumber.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetJobByPhoneNumberWithChan(request *GetJobByPhoneNumberRequest) (<-chan *GetJobByPhoneNumberResponse, <-chan error) {
	responseChan := make(chan *GetJobByPhoneNumberResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetJobByPhoneNumber(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetJobByPhoneNumberWithCallback invokes the outboundbot.GetJobByPhoneNumber API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/getjobbyphonenumber.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetJobByPhoneNumberWithCallback(request *GetJobByPhoneNumberRequest, callback func(response *GetJobByPhoneNumberResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetJobByPhoneNumberResponse
		var err error
		defer close(result)
		response, err = client.GetJobByPhoneNumber(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetJobByPhoneNumberRequest is the request struct for api GetJobByPhoneNumber
type GetJobByPhoneNumberRequest struct {
	*requests.RpcRequest
	PhoneNumber string `position:"Query" name:"PhoneNumber"`
	InstanceId  string `position:"Query" name:"InstanceId"`
	JobGroupId  string `position:"Query" name:"JobGroupId"`
}

// GetJobByPhoneNumberResponse is the response struct for api GetJobByPhoneNumber
type GetJobByPhoneNumberResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Jobs           []Job  `json:"Jobs" xml:"Jobs"`
}

// CreateGetJobByPhoneNumberRequest creates a request to invoke GetJobByPhoneNumber API
func CreateGetJobByPhoneNumberRequest() (request *GetJobByPhoneNumberRequest) {
	request = &GetJobByPhoneNumberRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "GetJobByPhoneNumber", "outboundbot", "openAPI")
	return
}

// CreateGetJobByPhoneNumberResponse creates a response to parse from GetJobByPhoneNumber response
func CreateGetJobByPhoneNumberResponse() (response *GetJobByPhoneNumberResponse) {
	response = &GetJobByPhoneNumberResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
