package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetTagHitsSummary invokes the outboundbot.GetTagHitsSummary API synchronously
// api document: https://help.aliyun.com/api/outboundbot/gettaghitssummary.html
func (client *Client) GetTagHitsSummary(request *GetTagHitsSummaryRequest) (response *GetTagHitsSummaryResponse, err error) {
	response = CreateGetTagHitsSummaryResponse()
	err = client.DoAction(request, response)
	return
}

// GetTagHitsSummaryWithChan invokes the outboundbot.GetTagHitsSummary API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/gettaghitssummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetTagHitsSummaryWithChan(request *GetTagHitsSummaryRequest) (<-chan *GetTagHitsSummaryResponse, <-chan error) {
	responseChan := make(chan *GetTagHitsSummaryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetTagHitsSummary(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetTagHitsSummaryWithCallback invokes the outboundbot.GetTagHitsSummary API asynchronously
// api document: https://help.aliyun.com/api/outboundbot/gettaghitssummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetTagHitsSummaryWithCallback(request *GetTagHitsSummaryRequest, callback func(response *GetTagHitsSummaryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetTagHitsSummaryResponse
		var err error
		defer close(result)
		response, err = client.GetTagHitsSummary(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetTagHitsSummaryRequest is the request struct for api GetTagHitsSummary
type GetTagHitsSummaryRequest struct {
	*requests.RpcRequest
	InstanceId string `position:"Query" name:"InstanceId"`
	JobGroupId string `position:"Query" name:"JobGroupId"`
}

// GetTagHitsSummaryResponse is the response struct for api GetTagHitsSummary
type GetTagHitsSummaryResponse struct {
	*responses.BaseResponse
	RequestId      string     `json:"RequestId" xml:"RequestId"`
	Success        bool       `json:"Success" xml:"Success"`
	Code           string     `json:"Code" xml:"Code"`
	Message        string     `json:"Message" xml:"Message"`
	HttpStatusCode int        `json:"HttpStatusCode" xml:"HttpStatusCode"`
	TagHitsList    []TagHits  `json:"TagHitsList" xml:"TagHitsList"`
	TagGroups      []TagGroup `json:"TagGroups" xml:"TagGroups"`
}

// CreateGetTagHitsSummaryRequest creates a request to invoke GetTagHitsSummary API
func CreateGetTagHitsSummaryRequest() (request *GetTagHitsSummaryRequest) {
	request = &GetTagHitsSummaryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "GetTagHitsSummary", "outboundbot", "openAPI")
	return
}

// CreateGetTagHitsSummaryResponse creates a response to parse from GetTagHitsSummary response
func CreateGetTagHitsSummaryResponse() (response *GetTagHitsSummaryResponse) {
	response = &GetTagHitsSummaryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
