package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateIPBlock invokes the waf_openapi.CreateIPBlock API synchronously
// api document: https://help.aliyun.com/api/waf-openapi/createipblock.html
func (client *Client) CreateIPBlock(request *CreateIPBlockRequest) (response *CreateIPBlockResponse, err error) {
	response = CreateCreateIPBlockResponse()
	err = client.DoAction(request, response)
	return
}

// CreateIPBlockWithChan invokes the waf_openapi.CreateIPBlock API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/createipblock.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateIPBlockWithChan(request *CreateIPBlockRequest) (<-chan *CreateIPBlockResponse, <-chan error) {
	responseChan := make(chan *CreateIPBlockResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateIPBlock(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateIPBlockWithCallback invokes the waf_openapi.CreateIPBlock API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/createipblock.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CreateIPBlockWithCallback(request *CreateIPBlockRequest, callback func(response *CreateIPBlockResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateIPBlockResponse
		var err error
		defer close(result)
		response, err = client.CreateIPBlock(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateIPBlockRequest is the request struct for api CreateIPBlock
type CreateIPBlockRequest struct {
	*requests.RpcRequest
	DomainList      string           `position:"Query" name:"DomainList"`
	IPList          string           `position:"Query" name:"IPList"`
	ResourceGroupId string           `position:"Query" name:"ResourceGroupId"`
	SourceIp        string           `position:"Query" name:"SourceIp"`
	BlockInterval   requests.Integer `position:"Query" name:"BlockInterval"`
	Lang            string           `position:"Query" name:"Lang"`
	OperationType   string           `position:"Query" name:"OperationType"`
	InstanceId      string           `position:"Query" name:"InstanceId"`
}

// CreateIPBlockResponse is the response struct for api CreateIPBlock
type CreateIPBlockResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateCreateIPBlockRequest creates a request to invoke CreateIPBlock API
func CreateCreateIPBlockRequest() (request *CreateIPBlockRequest) {
	request = &CreateIPBlockRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "CreateIPBlock", "waf", "openAPI")
	return
}

// CreateCreateIPBlockResponse creates a response to parse from CreateIPBlock response
func CreateCreateIPBlockResponse() (response *CreateIPBlockResponse) {
	response = &CreateIPBlockResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
