package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDomainStatus invokes the waf_openapi.DescribeDomainStatus API synchronously
// api document: https://help.aliyun.com/api/waf-openapi/describedomainstatus.html
func (client *Client) DescribeDomainStatus(request *DescribeDomainStatusRequest) (response *DescribeDomainStatusResponse, err error) {
	response = CreateDescribeDomainStatusResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDomainStatusWithChan invokes the waf_openapi.DescribeDomainStatus API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describedomainstatus.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDomainStatusWithChan(request *DescribeDomainStatusRequest) (<-chan *DescribeDomainStatusResponse, <-chan error) {
	responseChan := make(chan *DescribeDomainStatusResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDomainStatus(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDomainStatusWithCallback invokes the waf_openapi.DescribeDomainStatus API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describedomainstatus.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeDomainStatusWithCallback(request *DescribeDomainStatusRequest, callback func(response *DescribeDomainStatusResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDomainStatusResponse
		var err error
		defer close(result)
		response, err = client.DescribeDomainStatus(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDomainStatusRequest is the request struct for api DescribeDomainStatus
type DescribeDomainStatusRequest struct {
	*requests.RpcRequest
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	InstanceId      string `position:"Query" name:"InstanceId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	Domain          string `position:"Query" name:"Domain"`
	Lang            string `position:"Query" name:"Lang"`
}

// DescribeDomainStatusResponse is the response struct for api DescribeDomainStatus
type DescribeDomainStatusResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	ConfigStatus string `json:"ConfigStatus" xml:"ConfigStatus"`
}

// CreateDescribeDomainStatusRequest creates a request to invoke DescribeDomainStatus API
func CreateDescribeDomainStatusRequest() (request *DescribeDomainStatusRequest) {
	request = &DescribeDomainStatusRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "DescribeDomainStatus", "waf", "openAPI")
	return
}

// CreateDescribeDomainStatusResponse creates a response to parse from DescribeDomainStatus response
func CreateDescribeDomainStatusResponse() (response *DescribeDomainStatusResponse) {
	response = &DescribeDomainStatusResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
