package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRealProtectSummary invokes the waf_openapi.DescribeRealProtectSummary API synchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerealprotectsummary.html
func (client *Client) DescribeRealProtectSummary(request *DescribeRealProtectSummaryRequest) (response *DescribeRealProtectSummaryResponse, err error) {
	response = CreateDescribeRealProtectSummaryResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRealProtectSummaryWithChan invokes the waf_openapi.DescribeRealProtectSummary API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerealprotectsummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRealProtectSummaryWithChan(request *DescribeRealProtectSummaryRequest) (<-chan *DescribeRealProtectSummaryResponse, <-chan error) {
	responseChan := make(chan *DescribeRealProtectSummaryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRealProtectSummary(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRealProtectSummaryWithCallback invokes the waf_openapi.DescribeRealProtectSummary API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerealprotectsummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRealProtectSummaryWithCallback(request *DescribeRealProtectSummaryRequest, callback func(response *DescribeRealProtectSummaryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRealProtectSummaryResponse
		var err error
		defer close(result)
		response, err = client.DescribeRealProtectSummary(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRealProtectSummaryRequest is the request struct for api DescribeRealProtectSummary
type DescribeRealProtectSummaryRequest struct {
	*requests.RpcRequest
	StartTimestamp string `position:"Query" name:"StartTimestamp"`
	EndTimestamp   string `position:"Query" name:"EndTimestamp"`
	SourceIp       string `position:"Query" name:"SourceIp"`
	Lang           string `position:"Query" name:"Lang"`
	InstanceId     string `position:"Query" name:"InstanceId"`
	Domain         string `position:"Query" name:"Domain"`
	Step           string `position:"Query" name:"Step"`
	Region         string `position:"Query" name:"Region"`
}

// DescribeRealProtectSummaryResponse is the response struct for api DescribeRealProtectSummary
type DescribeRealProtectSummaryResponse struct {
	*responses.BaseResponse
	RequestId           string `json:"RequestId" xml:"RequestId"`
	RealProtectSummarys []Item `json:"RealProtectSummarys" xml:"RealProtectSummarys"`
}

// CreateDescribeRealProtectSummaryRequest creates a request to invoke DescribeRealProtectSummary API
func CreateDescribeRealProtectSummaryRequest() (request *DescribeRealProtectSummaryRequest) {
	request = &DescribeRealProtectSummaryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "DescribeRealProtectSummary", "waf", "openAPI")
	return
}

// CreateDescribeRealProtectSummaryResponse creates a response to parse from DescribeRealProtectSummary response
func CreateDescribeRealProtectSummaryResponse() (response *DescribeRealProtectSummaryResponse) {
	response = &DescribeRealProtectSummaryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
