package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRuleMonitor invokes the waf_openapi.DescribeRuleMonitor API synchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulemonitor.html
func (client *Client) DescribeRuleMonitor(request *DescribeRuleMonitorRequest) (response *DescribeRuleMonitorResponse, err error) {
	response = CreateDescribeRuleMonitorResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRuleMonitorWithChan invokes the waf_openapi.DescribeRuleMonitor API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulemonitor.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRuleMonitorWithChan(request *DescribeRuleMonitorRequest) (<-chan *DescribeRuleMonitorResponse, <-chan error) {
	responseChan := make(chan *DescribeRuleMonitorResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRuleMonitor(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRuleMonitorWithCallback invokes the waf_openapi.DescribeRuleMonitor API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulemonitor.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRuleMonitorWithCallback(request *DescribeRuleMonitorRequest, callback func(response *DescribeRuleMonitorResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRuleMonitorResponse
		var err error
		defer close(result)
		response, err = client.DescribeRuleMonitor(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRuleMonitorRequest is the request struct for api DescribeRuleMonitor
type DescribeRuleMonitorRequest struct {
	*requests.RpcRequest
	PageNumber      string `position:"Query" name:"PageNumber"`
	EndTimestamp    string `position:"Query" name:"EndTimestamp"`
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	PageSize        string `position:"Query" name:"PageSize"`
	Lang            string `position:"Query" name:"Lang"`
	InstanceId      string `position:"Query" name:"InstanceId"`
	Domain          string `position:"Query" name:"Domain"`
	Region          string `position:"Query" name:"Region"`
}

// DescribeRuleMonitorResponse is the response struct for api DescribeRuleMonitor
type DescribeRuleMonitorResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	TotalCount   int    `json:"TotalCount" xml:"TotalCount"`
	RuleMonitors []Item `json:"RuleMonitors" xml:"RuleMonitors"`
}

// CreateDescribeRuleMonitorRequest creates a request to invoke DescribeRuleMonitor API
func CreateDescribeRuleMonitorRequest() (request *DescribeRuleMonitorRequest) {
	request = &DescribeRuleMonitorRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "DescribeRuleMonitor", "waf", "openAPI")
	return
}

// CreateDescribeRuleMonitorResponse creates a response to parse from DescribeRuleMonitor response
func CreateDescribeRuleMonitorResponse() (response *DescribeRuleMonitorResponse) {
	response = &DescribeRuleMonitorResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
