package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRuleSummary invokes the waf_openapi.DescribeRuleSummary API synchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulesummary.html
func (client *Client) DescribeRuleSummary(request *DescribeRuleSummaryRequest) (response *DescribeRuleSummaryResponse, err error) {
	response = CreateDescribeRuleSummaryResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRuleSummaryWithChan invokes the waf_openapi.DescribeRuleSummary API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulesummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRuleSummaryWithChan(request *DescribeRuleSummaryRequest) (<-chan *DescribeRuleSummaryResponse, <-chan error) {
	responseChan := make(chan *DescribeRuleSummaryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRuleSummary(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRuleSummaryWithCallback invokes the waf_openapi.DescribeRuleSummary API asynchronously
// api document: https://help.aliyun.com/api/waf-openapi/describerulesummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeRuleSummaryWithCallback(request *DescribeRuleSummaryRequest, callback func(response *DescribeRuleSummaryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRuleSummaryResponse
		var err error
		defer close(result)
		response, err = client.DescribeRuleSummary(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRuleSummaryRequest is the request struct for api DescribeRuleSummary
type DescribeRuleSummaryRequest struct {
	*requests.RpcRequest
	EndTimestamp    string `position:"Query" name:"EndTimestamp"`
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	Lang            string `position:"Query" name:"Lang"`
	AntibotType     string `position:"Query" name:"AntibotType"`
	InstanceId      string `position:"Query" name:"InstanceId"`
	Domain          string `position:"Query" name:"Domain"`
	Region          string `position:"Query" name:"Region"`
	RuleId          string `position:"Query" name:"RuleId"`
}

// DescribeRuleSummaryResponse is the response struct for api DescribeRuleSummary
type DescribeRuleSummaryResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	RuleSummarys []Item `json:"RuleSummarys" xml:"RuleSummarys"`
}

// CreateDescribeRuleSummaryRequest creates a request to invoke DescribeRuleSummary API
func CreateDescribeRuleSummaryRequest() (request *DescribeRuleSummaryRequest) {
	request = &DescribeRuleSummaryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "DescribeRuleSummary", "waf", "openAPI")
	return
}

// CreateDescribeRuleSummaryResponse creates a response to parse from DescribeRuleSummary response
func CreateDescribeRuleSummaryResponse() (response *DescribeRuleSummaryResponse) {
	response = &DescribeRuleSummaryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
